## postgresql-9.0 9.0.23~20220624.1133-7~1.git289a0f0.pgdg18.04+1

=== src/backend/Makefile ===
#-------------------------------------------------------------------------
#
# Makefile for the postgres backend
#
# Portions Copyright (c) 1996-2010, PostgreSQL Global Development Group
# Portions Copyright (c) 1994, Regents of the University of California
#
# $PostgreSQL: pgsql/src/backend/Makefile,v 1.145 2010/07/05 18:54:37 tgl Exp $
#
#-------------------------------------------------------------------------

PGFILEDESC = "PostgreSQL Server"
# This is a daemon process, which is why it is not labeled as an executable
#PGAPPICON=win32

subdir = src/backend
top_builddir = ../..
include $(top_builddir)/src/Makefile.global

SUBDIRS = access bootstrap catalog parser commands executor foreign lib libpq \
	main nodes optimizer port postmaster regex replication rewrite \
	storage tcop tsearch utils $(top_builddir)/src/timezone

include $(srcdir)/common.mk

# As of 1/2010:
# The probes.o file is necessary for dtrace support on Solaris, and on recent
# versions of systemtap.  (Older systemtap releases just produce an empty
# file, but that's okay.)  However, OS X's dtrace doesn't use it and doesn't
# even recognize the -G option.  So, build probes.o except on Darwin.
# This might need adjustment as other platforms add dtrace support.
ifneq ($(PORTNAME), darwin)
ifeq ($(enable_dtrace), yes)
LOCALOBJS += utils/probes.o
endif
endif

OBJS = $(SUBDIROBJS) $(LOCALOBJS) $(top_builddir)/src/port/libpgport_srv.a

# We put libpgport into OBJS, so remove it from LIBS; also add libldap
LIBS := $(filter-out -lpgport, $(LIBS)) $(LDAP_LIBS_BE)

# The backend doesn't need everything that's in LIBS, however
LIBS := $(filter-out -lz -lreadline -ledit -ltermcap -lncurses -lcurses, $(LIBS))

##########################################################################

all: submake-libpgport submake-schemapg postgres $(POSTGRES_IMP)

ifneq ($(PORTNAME), cygwin)
ifneq ($(PORTNAME), win32)
ifneq ($(PORTNAME), aix)

postgres: $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) $(export_dynamic) $(call expand_subsys,$^) $(LIBS) -o $@

endif
endif
endif

ifeq ($(PORTNAME), cygwin)

postgres: $(OBJS) postgres.def libpostgres.a
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack,$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # cygwin

ifeq ($(PORTNAME), win32)
LIBS += -lsecur32

postgres: $(OBJS) postgres.def libpostgres.a $(WIN32RES)
	$(DLLTOOL) --dllname $@$(X) --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -o $@$(X) -Wl,--base-file,$@.base $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	$(DLLTOOL) --dllname $@$(X) --base-file $@.base --output-exp $@.exp --def postgres.def
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) -Wl,--stack=$(WIN32_STACK_RLIMIT) -o $@$(X) $@.exp $(call expand_subsys,$(OBJS)) $(WIN32RES) $(LIBS)
	rm -f $@.exp $@.base

postgres.def: $(OBJS)
	$(DLLTOOL) --export-all --output-def $@ $(call expand_subsys,$^)

libpostgres.a: postgres.def
	$(DLLTOOL) --dllname postgres.exe --def postgres.def --output-lib $@

endif # win32

ifeq ($(PORTNAME), aix)

postgres: $(POSTGRES_IMP)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$(OBJS)) -Wl,-bE:$(top_builddir)/src/backend/$(POSTGRES_IMP) $(LIBS) -Wl,-brtllib -o $@

$(POSTGRES_IMP): $(OBJS)
	$(LD) $(LDREL) $(LDOUT) SUBSYS.o $(call expand_subsys,$^)
ifeq ($(host_os), aix3.2.5)
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
ifneq (,$(findstring aix4.1, $(host_os)))
	$(MKLDEXPORT) SUBSYS.o $(bindir)/postgres > $@
else
	$(MKLDEXPORT) SUBSYS.o . > $@
endif
endif
	@rm -f SUBSYS.o

endif # aix

# Update the commonly used headers before building the subdirectories
$(SUBDIRS:%=%-recursive): $(top_builddir)/src/include/parser/gram.h $(top_builddir)/src/include/catalog/schemapg.h $(top_builddir)/src/include/utils/fmgroids.h $(top_builddir)/src/include/utils/probes.h

# run this unconditionally to avoid needing to know its dependencies here:
submake-schemapg:
	$(MAKE) -C catalog schemapg.h

.PHONY: submake-schemapg

catalog/schemapg.h: | submake-schemapg


# The postgres.o target is needed by the rule in Makefile.global that
# creates the exports file when MAKE_EXPORTS = true.
postgres.o: $(OBJS)
	$(CC) $(LDREL) $(LDFLAGS) $(LDFLAGS_EX) $(call expand_subsys,$^) $(LIBS) -o $@


# The following targets are specified in make commands that appear in
# the make files in our subdirectories. Note that it's important we
# match the dependencies shown in the subdirectory makefiles!

parser/gram.h: parser/gram.y
	$(MAKE) -C parser gram.h

utils/fmgroids.h: utils/Gen_fmgrtab.pl catalog/Catalog.pm $(top_srcdir)/src/include/catalog/pg_proc.h
	$(MAKE) -C utils fmgroids.h

utils/probes.h: utils/probes.d
	$(MAKE) -C utils probes.h

# Make symlinks for these headers in the include directory. That way
# we can cut down on the -I options. Also, a symlink is automatically
# up to date when we update the base file.
#
# The point of the prereqdir incantation in some of the rules below is to
# force the symlink to use an absolute path rather than a relative path.
# For headers which are generated by make distprep, the actual header within
# src/backend will be in the source tree, while the symlink in src/include
# will be in the build tree, so a simple ../.. reference won't work.
# For headers generated during regular builds, we prefer a relative symlink.

$(top_builddir)/src/include/parser/gram.h: parser/gram.h
	prereqdir=`cd $(dir $<) >/dev/null && pwd` && \
	  cd $(dir $@) && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/catalog/schemapg.h: catalog/schemapg.h
	prereqdir=`cd $(dir $<) >/dev/null && pwd` && \
	  cd $(dir $@) && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/fmgroids.h: utils/fmgroids.h
	prereqdir=`cd $(dir $<) >/dev/null && pwd` && \
	  cd $(dir $@) && rm -f $(notdir $@) && \
	  $(LN_S) "$$prereqdir/$(notdir $<)" .

$(top_builddir)/src/include/utils/probes.h: utils/probes.h
	cd $(dir $@) && rm -f $(notdir $@) && \
	    $(LN_S) ../../../$(subdir)/utils/probes.h .


utils/probes.o: utils/probes.d $(SUBDIROBJS)
	$(DTRACE) $(DTRACEFLAGS) -C -G -s $(call expand_subsys,$^) -o $@


##########################################################################

distprep:
	$(MAKE) -C parser	gram.c gram.h scan.c
	$(MAKE) -C bootstrap	bootparse.c bootscanner.c
	$(MAKE) -C catalog	schemapg.h postgres.bki postgres.description postgres.shdescription
	$(MAKE) -C utils	fmgrtab.c fmgroids.h 
	$(MAKE) -C utils/misc	guc-file.c


##########################################################################

install: all installdirs install-bin
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(INSTALL_DATA) libpostgres.a '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog install-data
	$(MAKE) -C tsearch install-data
	$(INSTALL_DATA) $(srcdir)/libpq/pg_hba.conf.sample '$(DESTDIR)$(datadir)/pg_hba.conf.sample'
	$(INSTALL_DATA) $(srcdir)/libpq/pg_ident.conf.sample '$(DESTDIR)$(datadir)/pg_ident.conf.sample'
	$(INSTALL_DATA) $(srcdir)/utils/misc/postgresql.conf.sample '$(DESTDIR)$(datadir)/postgresql.conf.sample'
	$(INSTALL_DATA) $(srcdir)/access/transam/recovery.conf.sample '$(DESTDIR)$(datadir)/recovery.conf.sample'

install-bin: postgres $(POSTGRES_IMP) installdirs
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postgres$(X)'
ifneq ($(PORTNAME), win32)
	@rm -f '$(DESTDIR)$(bindir)/postmaster$(X)'
	ln -s postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
else
	$(INSTALL_PROGRAM) postgres$(X) '$(DESTDIR)$(bindir)/postmaster$(X)'
endif
ifeq ($(MAKE_EXPORTS), true)
	$(INSTALL_DATA) $(POSTGRES_IMP) '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
	$(INSTALL_PROGRAM) $(MKLDEXPORT) '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)/mkldexport.sh'
endif

.PHONY: install-bin

installdirs:
	$(MKDIR_P) '$(DESTDIR)$(bindir)' '$(DESTDIR)$(datadir)'
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	$(MKDIR_P) '$(DESTDIR)$(libdir)'
endif
endif
ifeq ($(MAKE_EXPORTS), true)
	$(MKDIR_P) '$(DESTDIR)$(pkglibdir)'
	$(MKDIR_P) '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)'
endif


##########################################################################

uninstall:
	rm -f '$(DESTDIR)$(bindir)/postgres$(X)' '$(DESTDIR)$(bindir)/postmaster'
ifeq ($(MAKE_EXPORTS), true)
	rm -f '$(DESTDIR)$(pkglibdir)/$(POSTGRES_IMP)'
	rm -f '$(DESTDIR)$(pgxsdir)/$(MKLDEXPORT_DIR)/mkldexport.sh'
endif
ifeq ($(PORTNAME), cygwin)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
ifeq ($(PORTNAME), win32)
ifeq ($(MAKE_DLL), true)
	rm -f '$(DESTDIR)$(libdir)/libpostgres.a'
endif
endif
	$(MAKE) -C catalog uninstall-data
	$(MAKE) -C tsearch uninstall-data
	rm -f '$(DESTDIR)$(datadir)/pg_hba.conf.sample' \
	      '$(DESTDIR)$(datadir)/pg_ident.conf.sample' \
              '$(DESTDIR)$(datadir)/postgresql.conf.sample' \
	      '$(DESTDIR)$(datadir)/recovery.conf.sample'


##########################################################################

clean:
	rm -f $(LOCALOBJS) postgres$(X) $(POSTGRES_IMP) \
		$(top_builddir)/src/include/parser/gram.h \
		$(top_builddir)/src/include/catalog/schemapg.h \
		$(top_builddir)/src/include/utils/fmgroids.h \
		$(top_builddir)/src/include/utils/probes.h
ifeq ($(PORTNAME), cygwin)
	rm -f postgres.dll postgres.def libpostgres.a
endif
ifeq ($(PORTNAME), win32)
	rm -f postgres.dll postgres.def libpostgres.a $(WIN32RES)
endif

distclean: clean
	rm -f port/tas.s port/dynloader.c port/pg_sema.c port/pg_shmem.c

maintainer-clean: distclean
	rm -f bootstrap/bootparse.c \
	      bootstrap/bootscanner.c \
	      parser/gram.c \
	      parser/scan.c \
	      parser/gram.h \
	      catalog/schemapg.h \
	      catalog/postgres.bki \
	      catalog/postgres.description \
	      catalog/postgres.shdescription \
	      utils/fmgroids.h \
	      utils/fmgrtab.c \
	      utils/misc/guc-file.c


##########################################################################
#
# Support for code development.
#
# Use target "quick" to build "postgres" when you know all the subsystems 
# are up to date.  It saves the time of doing all the submakes.
.PHONY: quick
quick: $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $(LDFLAGS_EX) $(export_dynamic) $(call expand_subsys,$^) $(LIBS) -o postgres

## postgresql-9.0 9.0.4

=== debian/changelog ===
postgresql-9.0 (9.0.4-1) unstable; urgency=medium

  Priority medium due to data-loss pg_upgrade bug.

  * New upstream bug fix release:
    - If your installation was upgraded from a previous major release by
      running pg_upgrade, you should take action to prevent possible data loss
      due to a now-fixed bug in pg_upgrade. The recommended solution is to run
      "VACUUM FREEZE" on all TOAST tables.  More information is available at
      http://wiki.postgresql.org/wiki/20110408pg_upgrade_fix.
    - Fix pg_upgrade's handling of TOAST tables.
      This error poses a significant risk of data loss for installations
      that have been upgraded with pg_upgrade. This patch corrects the
      problem for future uses of pg_upgrade, but does not in itself cure
      the issue in installations that have been processed with a buggy
      version of pg_upgrade.
    - Suppress incorrect "PD_ALL_VISIBLE flag was incorrectly set"
      warning.
    - Use better SQLSTATE error codes for hot standby conflict cases.
    - Prevent intermittent hang in interactions of startup process with
      bgwriter process.  This affected recovery in non-hot-standby cases.
    - Disallow including a composite type in itself.
    - Avoid potential deadlock during catalog cache initialization.
    - Fix dangling-pointer problem in BEFORE ROW UPDATE trigger handling
      when there was a concurrent update to the target tuple.
    - Disallow "DROP TABLE" when there are pending deferred trigger
      events for the table.
      Formerly the "DROP" would go through, leading to "could not open
      relation with OID nnn" errors when the triggers were eventually
      fired.
    - Allow "replication" as a user name in "pg_hba.conf".
      "replication" is special in the database name column, but it was
      mistakenly also treated as special in the user name column.
    - Prevent crash triggered by constant-false WHERE conditions during
      GEQO optimization.
    - Improve planner's handling of semi-join and anti-join cases.
    - Fix handling of SELECT FOR UPDATE in a sub-SELECT.
      This bug typically led to "cannot extract system attribute from
      virtual tuple" errors.
    - Fix selectivity estimation for text search to account for NULLs.
    - Fix get_actual_variable_range() to support hypothetical indexes
      injected by an index adviser plugin.
    - Fix PL/Python memory leak involving array slices.
    - Allow libpq's SSL initialization to succeed when user's home
      directory is unavailable.
      If the SSL mode is such that a root certificate file is not
      required, there is no need to fail. This change restores the
      behavior to what it was in pre-9.0 releases.
    - Fix libpq to return a useful error message for errors detected in
      conninfo_array_parse.
    - Fix ecpg preprocessor's handling of float constants.
    - Fix parallel pg_restore to handle comments on POST_DATA items
      correctly.
    - Fix pg_restore to cope with long lines (over 1KB) in TOC files.
    - Put in more safeguards against crashing due to division-by-zero
      with overly enthusiastic compiler optimization. (Closes: #616180)
  * debian/control: Build debug package. (Closes: #551880)
  * debian/control, debian/rules: Drop usage of pycentral. We don't ship any
    Python extension/module, so we don't need a python helper at all.
    (Closes: #616949)

 -- Martin Pitt <mpitt@debian.org>  Wed, 20 Apr 2011 15:08:32 +0200

postgresql-9.0 (9.0.3-1) unstable; urgency=low

  * New upstream security/bug fix release:
    - Fix buffer overrun in "contrib/intarray"'s input function for the
      query_int type.
      This bug is a security risk since the function's return address
      could be overwritten. Thanks to Apple Inc's security team for
      reporting this issue and supplying the fix. (CVE-2010-4015)
    - Before exiting walreceiver, ensure all the received WAL is fsync'd
      to disk. Otherwise the standby server could replay some un-synced WAL,
      conceivably leading to data corruption if the system crashes just
      at that point.
    - Avoid excess fsync activity in walreceiver.
    - Make "ALTER TABLE" revalidate uniqueness and exclusion constraints
      when needed. This was broken in 9.0 by a change that was intended to
      suppress revalidation during "VACUUM FULL" and "CLUSTER", but
      unintentionally affected "ALTER TABLE" as well.
    - Fix EvalPlanQual for "UPDATE" of an inheritance tree in which the
      tables are not all alike.
      Any variation in the table row types (including dropped columns
      present in only some child tables) would confuse the EvalPlanQual
      code, leading to misbehavior or even crashes. Since EvalPlanQual is
      only executed during concurrent updates to the same row, the
      problem was only seen intermittently.
    - Avoid failures when "EXPLAIN" tries to display a simple-form CASE
      expression.
      If the CASE's test expression was a constant, the planner could
      simplify the CASE into a form that confused the expression-display
      code, resulting in "unexpected CASE WHEN clause" errors.
    - Fix assignment to an array slice that is before the existing range
      of subscripts.
      If there was a gap between the newly added subscripts and the first
      pre-existing subscript, the code miscalculated how many entries
      needed to be copied from the old array's null bitmap, potentially
      leading to data corruption or crash.
    - Avoid unexpected conversion overflow in planner for very distant
      date values.
      The date type supports a wider range of dates than can be
      represented by the timestamp types, but the planner assumed it
      could always convert a date to timestamp with impunity.
    - Fix PL/Python crash when an array contains null entries.
    - Remove ecpg's fixed length limit for constants defining an array
      dimension.


=== debian/control ===
Source: postgresql-9.0
Section: database
Priority: optional
Maintainer: Martin Pitt <mpitt@debian.org>
Uploaders: Peter Eisentraut <petere@debian.org>
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 5.0.37.2), cdbs (>= 0.4.43), perl (>= 5.8),
 libperl-dev, tcl8.5-dev, libedit-dev, libssl-dev, 
 zlib1g-dev | libz-dev, libpam0g-dev | libpam-dev, libxml2-dev, libkrb5-dev,
 libldap2-dev, libxslt1-dev, libossp-uuid-dev, python-dev,
 gettext, hardening-wrapper
Homepage: http://www.postgresql.org/
Vcs-Browser: http://bazaar.launchpad.net/~pitti/postgresql/debian-9.0
Vcs-Bzr: https://code.launchpad.net/~pitti/postgresql/debian-9.0

Package: libpq-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libpq5 (= ${binary:Version}), libssl-dev, libkrb5-dev, comerr-dev
Conflicts: postgresql-dev (<< 7.5)
Replaces: postgresql-dev
Suggests: postgresql-doc-9.0
Description: header files for libpq5 (PostgreSQL library)
 Header files and static library for compiling C programs to link
 with the libpq library in order to communicate with a PostgreSQL
 database backend.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpq5
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: PostgreSQL C client library
 libpq is a C library that enables user programs to communicate with
 the PostgreSQL database server.  The server can be on another machine
 and accessed through TCP/IP.  This version of libpq is compatible
 with servers from PostgreSQL 8.2 or later.
 .
 This package contains the run-time library, needed by packages using
 libpq.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: run-time library for ECPG programs
 The libecpg shared library is used by programs built with ECPG
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libecpg-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libpq-dev, libecpg6 (= ${binary:Version}), libecpg-compat3 (= ${binary:Version}), libpgtypes3 (= ${binary:Version})
Conflicts: postgresql-dev, libecpg3-dev
Description: development files for ECPG (Embedded PostgreSQL for C)
 This package contains the necessary files to build ECPG (Embedded
 PostgreSQL for C) programs.  It includes the development libraries
 and the preprocessor program ecpg.
 .
 PostgreSQL is an object-relational SQL database management system.
 .
 Install this package if you want to write C programs with SQL statements
 embedded in them (rather than run by an external process).

Package: libecpg-compat3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: older version of run-time library for ECPG programs
 The libecpg_compat shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: libpgtypes3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared library libpgtypes for PostgreSQL 9.0
 The libpgtypes shared library is used by programs built with ecpg.
 (Embedded PostgreSQL for C).
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-9.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-client-9.0, postgresql-common (>= 109~), tzdata, ssl-cert, locales
Suggests: oidentd | ident-server
Conflicts: postgresql (<< 7.5)
Description: object-relational SQL database, version 9.0 server
 PostgreSQL is a fully featured object-relational database management
 system.  It supports a large part of the SQL standard and is designed
 to be extensible by users in many aspects.  Some of the features are:
 ACID transactions, foreign keys, views, sequences, subqueries,
 triggers, user-defined types and functions, outer joins, multiversion
 concurrency control.  Graphical user interfaces and bindings for many
 programming languages are available as well.
 .
 This package provides the database server for PostgreSQL 9.0. Servers
 for other major release versions can be installed simultaneously and
 are coordinated by the postgresql-common package. A package providing
 ident-server is needed if you want to authenticate remote connections
 with identd.

Package: postgresql-9.0-dbg
Section: debug
Priority: extra
Architecture: any
Depends: postgresql-9.0 (= ${binary:Version})
Description: debug symbols for postgresql-9.0
 PostgreSQL is a fully featured object-relational database management
 system.  It supports a large part of the SQL standard and is designed
 to be extensible by users in many aspects.  Some of the features are:
 ACID transactions, foreign keys, views, sequences, subqueries,
 triggers, user-defined types and functions, outer joins, multiversion
 concurrency control.  Graphical user interfaces and bindings for many
 programming languages are available as well.
 .
 This package provides detached debugging symbols for PostgreSQL 9.0.

Package: postgresql-client-9.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-client-common (>= 107~)
Conflicts: postgresql (<< 7.5)
Suggests: postgresql-9.0, postgresql-doc-9.0
Provides: postgresql-client
Description: front-end programs for PostgreSQL 9.0
 This package contains client and administrative programs for
 PostgreSQL: these are the interactive terminal client psql and
 programs for creating and removing users and databases.
 .
 This is the client package for PostgreSQL 9.0. If you install
 PostgreSQL 9.0 on a standalone machine, you need the server package
 postgresql-9.0, too. On a network, you can install this package on
 many client machines, while the server package may be installed on
 only one machine.
 .  
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-server-dev-9.0
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libpq-dev (>= 9.0~)
Description: development files for PostgreSQL 9.0 server-side programming
 Header files for compiling SSI code to link into PostgreSQL's backend; for
 example, for C functions to be called from SQL.
 .
 This package also contains the Makefiles necessary for building add-on 
 modules of PostgreSQL, which would otherwise have to be built in the
 PostgreSQL source-code tree.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-doc-9.0
Architecture: all
Section: doc
Depends: ${misc:Depends}
Conflicts: postgresql-doc (<< 7.5)
Description: documentation for the PostgreSQL database management system
 This package contains all README files, user manual, and examples for
 PostgreSQL 9.0. The manual is in HTML format.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-contrib-9.0
Architecture: any
Depends: postgresql-9.0, ${misc:Depends}, ${shlibs:Depends}, postgresql-common (>= 109~)
Suggests: libdbd-pg-perl
Conflicts: postgresql-contrib (<< 7.5)
Description: additional facilities for PostgreSQL
 The PostgreSQL contrib package provides several additional features
 for the PostgreSQL database. This version is built to work with the
 server package postgresql-9.0.  contrib often serves as a testbed for
 features before they are adopted into PostgreSQL proper:
 .
  adminpack      - File and log manipulation routines, used by pgAdmin
  btree_gist     - B-Tree indexing using GiST (Generalised Search Tree)
  chkpass        - An auto-encrypted password datatype
  cube           - Multidimensional-cube datatype (GiST indexing example)
  dblink         - Functions to return results from a remote database
  earthdistance  - Operator for computing the distance (in miles) between
                   two points on the earth's surface
  fuzzystrmatch  - Levenshtein, metaphone, and soundex fuzzy string matching
  hstore         - Store (key, value) pairs
  intagg         - Integer aggregator/enumerator
  _int           - Index support for arrays of int4, using GiST (benchmark
                   needs the libdbd-pg-perl package)
  isn            - type extensions for ISBN, ISSN, ISMN, EAN13 product numbers
  lo             - Large Object maintenance
  ltree          - Tree-like data structures
  oid2name       - Maps OIDs to table names
  pageinspect    - Inspection of database pages
  passwordcheck  - Simple password strength checker
  pg_buffercache - Real time queries on the shared buffer cache
  pg_freespacemap- Displays the contents of the free space map (FSM)
  pg_trgm        - Determine the similarity of text based on trigram matching
  pg_standby     - Create a warm stand-by server
  pgbench        - TPC-B like benchmark
  pgcrypto       - Cryptographic functions
  pgrowlocks     - A function to return row locking information
  pgstattuple    - Returns the percentage of dead tuples in a table; this
                   indicates whether a vacuum is required.
  seg            - Confidence-interval datatype (GiST indexing example)
  spi            - PostgreSQL Server Programming Interface; 4 examples of
                   its use:
                   autoinc    - A function for implementing AUTOINCREMENT/
                                IDENTITY
                   insert_username - function for inserting user names
                   moddatetime - Update modification timestamps
                   refint     - Functions for implementing referential
                                integrity (foreign keys).  Note that this is
                                now superseded by built-in referential
                                integrity.
                   timetravel - Re-implements in user code the time travel
                                feature that was removed in 6.3.
  tablefunc      - examples of functions returning tables
  uuid-ossp      - UUID generation functions
  vacuumlo       - Remove orphaned large objects
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plperl-9.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-9.0, perl
Description: PL/Perl procedural language for PostgreSQL 9.0
 PL/Perl enables an SQL developer to write procedural language functions
 for PostgreSQL 9.0 in Perl.  You need this package if you have any
 PostgreSQL 9.0 functions that use the languages plperl or plperlu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-plpython-9.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-9.0
Description: PL/Python procedural language for PostgreSQL 9.0
 PL/Python enables an SQL developer to write procedural language functions
 for PostgreSQL 9.0 in Python.  You need this package if you have any
 PostgreSQL 9.0 functions that use the languages plpython or plpythonu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql-pltcl-9.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, postgresql-9.0
Description: PL/Tcl procedural language for PostgreSQL 9.0
 PL/Tcl enables an SQL developer to write procedural language functions
 for PostgreSQL 9.0 in Tcl.  You need this package if you have any
 PostgreSQL 9.0 functions that use the languages pltcl or pltclu.
 .
 PostgreSQL is an object-relational SQL database management system.

Package: postgresql
Architecture: all
Depends: postgresql-9.0, ${misc:Depends}
Description: object-relational SQL database (supported version)
 PostgreSQL is a fully featured object-relational database management
 system.  It supports a large part of the SQL standard and is designed
 to be extensible by users in many aspects.  Some of the features are:
 ACID transactions, foreign keys, views, sequences, subqueries,
 triggers, user-defined types and functions, outer joins, multiversion

=== debian/rules ===
#!/usr/bin/make	-f 
TCL_VER := 8.5
MAJOR_VER := 9.0

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk

LDFLAGS+= -Wl,--as-needed
CFLAGS+= -fPIC

ifneq ($(findstring $(DEB_BUILD_ARCH), sparc alpha),)
# sparc and alpha's gcc currently miscompiles; see
# http://lists.debian.org/debian-alpha/2007/11/msg00025.html
    CFLAGS+=-O1
endif

export DEB_BUILD_HARDENING=1

# build should fail on test suite failures on all arches
TESTSUITE_FAIL_CMD=exit 1

DEB_DH_INSTALL_SOURCEDIR=debian/tmp
DEB_CONFIGURE_EXTRA_FLAGS := --mandir=\$${prefix}/share/postgresql/$(MAJOR_VER)/man \
  --with-docdir=\$${prefix}/share/doc/postgresql-doc-$(MAJOR_VER) \
  --sysconfdir=/etc/postgresql-common \
  --datadir=\$${prefix}/share/postgresql/$(MAJOR_VER) \
  --bindir=\$${prefix}/lib/postgresql/$(MAJOR_VER)/bin \
  --includedir=\$${prefix}/include/postgresql/ \
  --enable-nls \
  --enable-integer-datetimes \
  --enable-thread-safety \
  --enable-debug \
  --disable-rpath \
  --with-tcl \
  --with-perl \
  --with-python \
  --with-pam \
  --with-krb5 \
  --with-gssapi \
  --with-openssl \
  --with-libxml \
  --with-libxslt \
  --with-ldap \
  --with-ossp-uuid \
  --with-gnu-ld \
  --with-tclconfig=/usr/lib/tcl$(TCL_VER) \
  --with-tkconfig=/usr/lib/tk$(TCL_VER) \
  --with-includes=/usr/include/tcl$(TCL_VER) \
  --with-system-tzdata=/usr/share/zoneinfo \
  --with-pgport=5432 \
  $(ARCH_OPTS) \
  CFLAGS='$(CFLAGS)' \
  LDFLAGS='$(LDFLAGS)'

DEB_MAKE_BUILD_TARGET = world
DEB_MAKE_INSTALL_TARGET := $(patsubst install,install-world,$(DEB_MAKE_INSTALL_TARGET))

DEB_DH_MAKESHLIBS_ARGS := -Xusr/lib/postgresql/$(MAJOR_VER)
DEB_DH_INSTALLCHANGELOGS_ARGS := HISTORY
DEB_COMPRESS_EXCLUDE := .source .c
DPKG_GENSYMBOLS_CHECK_LEVEL=4
export DPKG_GENSYMBOLS_CHECK_LEVEL

common-binary-predeb-arch::
	# verify that all files are installed; ignore manpages, since
	# they are handled by dh_installman
	missing=`dh_install --sourcedir=debian/tmp --list-missing --no-act 2>&1 | grep -v man/man`; \
	if [ -n "$$missing" ]; then \
	    echo "Not all files are installed:"; \
	    echo "$$missing"; \
	    exit 1; \
	fi

common-post-build-arch::
	# generate POT files for translators
	find -name nls.mk -exec sh -c "make -C \$$(dirname {}) init-po" \;
	
common-post-build-indep::
	# build tutorial stuff
	make -C src/tutorial NO_PGXS=1

install/postgresql-doc-$(MAJOR_VER)::
	install src/tutorial/*.c src/tutorial/*.source src/tutorial/Makefile src/tutorial/README debian/$(cdbs_curpkg)/usr/share/doc/$(cdbs_curpkg)/tutorial

binary-predeb/postgresql-$(MAJOR_VER)::
ifeq (, $(findstring nocheck, $(DEB_BUILD_OPTIONS)))
	# patch away the "don't execute as root" check for the test
	# suite; doing it here will ensure that the actual debs have
	# the check.
	set -e; \
	patch --no-backup-if-mismatch -p1 < debian/disable-root-check.patch; \
	make -C src/test/regress bigcheck || fail=1; \
	patch --no-backup-if-mismatch -Rp1 < debian/disable-root-check.patch; \
	if [ -n "$$fail" ]; then \
	    for l in regression.diffs log/initdb.log log/postmaster.log; do \
	    	if [ -e src/test/regress/$$l ]; then \
		    echo "********* $$l *******"; \
		    cat src/test/regress/$$l; \
		fi; \
	    done; \
	    $(TESTSUITE_FAIL_CMD); \
	fi
endif

	# compress manpages
	find debian/postgresql-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/man -type f -exec gzip -9 '{}' \;

binary-predeb/postgresql-client-$(MAJOR_VER)::
	find debian/postgresql-client-$(MAJOR_VER)/usr/share/postgresql/$(MAJOR_VER)/man -type f -exec gzip -9 '{}' \;

# run tests in contrib in temporary test installations, using programs
# from local tree
contrib-check:
	set -e; cd contrib; \
	for d in *; do \
	    [ -d $$d/sql ] || continue; \
	    echo "==============  Running tests in $$d"; \
	    (cd $$d; \
	    if ! ../../src/test/regress/pg_regress --top-builddir=../.. --temp-install=tmp_check --dbname=contrib_regression `cd sql; ls *.sql | sed 's/.sql$$//'`; then \
		 cat regression.diffs; \
	    fi); \
	done

# run tests in contrib in temporary test installation, using programs
# from system installation
contrib-installcheck:
	# set up temporary db
	rm -rf tmp_data
	mkdir tmp_data
	/usr/lib/postgresql/$(MAJOR_VER)/bin/initdb -D tmp_data
	/usr/lib/postgresql/$(MAJOR_VER)/bin/pg_ctl -D tmp_data -l tmp_data/postgres.log -o '-k /tmp' start
	# wait until it started up
	while !/usr/lib/postgresql/$(MAJOR_VER)/bin/psql -h /tmp -l >/dev/null 2>&1; do sleep 1; done
	sleep 1
	while !/usr/lib/postgresql/$(MAJOR_VER)/bin/psql -h /tmp -l >/dev/null 2>&1; do sleep 1; done
	# run the tests
	-cd contrib; make installcheck
	/usr/lib/postgresql/$(MAJOR_VER)/bin/pg_ctl -D tmp_data stop
	# find and print the regression diffs
	find contrib/ -name regression.diffs -exec cat '{}' \;

## postgresql-9.0 9.0.5

=== debian/changelog ===
postgresql-9.0 (9.0.5-1) unstable; urgency=low

  * New upstream bug fix release:
    - Fix catalog cache invalidation after a "VACUUM FULL" or "CLUSTER"
      on a system catalog. In some cases the relocation of a system catalog
      row to another place would not be recognized by concurrent server
      processes, allowing catalog corruption to occur if they then tried to
      update that row. The worst-case outcome could be as bad as complete loss
      of a table.
    - Fix incorrect order of operations during sinval reset processing,
      and ensure that TOAST OIDs are preserved in system catalogs.
      These mistakes could lead to transient failures after a "VACUUM
      FULL" or "CLUSTER" on a system catalog.
    - Fix bugs in indexing of in-doubt HOT-updated tuples.
      These bugs could result in index corruption after reindexing a
      system catalog. They are not believed to affect user indexes.
    - Fix multiple bugs in GiST index page split processing.
    - Fix possible buffer overrun in tsvector_concat().
    - Fix crash in xml_recv when processing a "standalone" parameter.
    - Make pg_options_to_table return NULL for an option with no value.
      Previously such cases would result in a server crash.
    - Avoid possibly accessing off the end of memory in "ANALYZE" and in
      SJIS-2004 encoding conversion.
      This fixes some very-low-probability server crash scenarios.
    - Protect pg_stat_reset_shared() against NULL input.
    - Fix possible failure when a recovery conflict deadlock is detected
      within a sub-transaction.
    - Avoid spurious conflicts while recycling btree index pages during
      hot standby.
    - Shut down WAL receiver if it's still running at end of recovery.
      The postmaster formerly panicked in this situation, but it's
      actually a legitimate case.
    - Fix race condition in relcache init file invalidation.
      There was a window wherein a new backend process could read a stale
      init file but miss the inval messages that would tell it the data
      is stale. The result would be bizarre failures in catalog accesses,
      typically "could not read block 0 in file ..." later during
      startup.
    - Fix memory leak at end of a GiST index scan.
    - Fix memory leak when encoding conversion has to be done on incoming
      command strings and "LISTEN" is active.
    - Fix incorrect memory accounting (leading to possible memory bloat)
      in tuplestores supporting holdable cursors and plpgsql's RETURN
      NEXT command.
    - Fix trigger WHEN conditions when both BEFORE and AFTER triggers
      exist.  Evaluation of WHEN conditions for AFTER ROW UPDATE triggers
      could crash if there had been a BEFORE ROW trigger fired for the same
      update.
    - Fix performance problem when constructing a large, lossy bitmap.
    - Fix join selectivity estimation for unique columns.
    - Fix nested PlaceHolderVar expressions that appear only in
      sub-select target lists. This mistake could result in outputs of an
      outer join incorrectly appearing as NULL.
    - Allow the planner to assume that empty parent tables really are
      empty.  Normally an empty table is assumed to have a certain minimum
      size for planning purposes; but this heuristic seems to do more harm
      than good for the parent table of an inheritance hierarchy, which
      often is permanently empty.
    - Allow nested EXISTS queries to be optimized properly.
    - Fix array- and path-creating functions to ensure padding bytes are
      zeroes. This avoids some situations where the planner will think that
      semantically-equal constants are not equal, resulting in poor
      optimization.
    - Fix "EXPLAIN" to handle gating Result nodes within inner-indexscan
      subplans.  The usual symptom of this oversight was "bogus varno" errors.
    - Fix btree preprocessing of "indexedcol" IS NULL conditions.
      Such a condition is unsatisfiable if combined with any other type
      of btree-indexable condition on the same index column. The case was
      handled incorrectly in 9.0.0 and later, leading to query output
      where there should be none.
    - Work around gcc 4.6.0 bug that breaks WAL replay.
      This could lead to loss of committed transactions after a server
      crash.
    - Fix dump bug for VALUES in a view.
    - Disallow SELECT FOR UPDATE/SHARE on sequences.
      This operation doesn't work as expected and can lead to failures.
    - Fix "VACUUM" so that it always updates pg_class.reltuples/relpages.
      This fixes some scenarios where autovacuum could make increasingly
      poor decisions about when to vacuum tables.
    - Defend against integer overflow when computing size of a hash table.
    - Fix cases where "CLUSTER" might attempt to access already-removed
      TOAST data.
    - Fix premature timeout failures during initial authentication
      transaction.
    - Fix portability bugs in use of credentials control messages for
      "peer" authentication. (see #627596, already fixed in Debian before)
    - Fix SSPI login when multiple roundtrips are required. The typical
      symptom of this problem was "The function requested is not supported"
      errors during SSPI login.
    - Fix failure when adding a new variable of a custom variable class
      to "postgresql.conf".
    - Throw an error if "pg_hba.conf" contains hostssl but SSL is
      disabled.  This was concluded to be more user-friendly than the previous
      behavior of silently ignoring such lines.
    - Fix failure when "DROP OWNED BY" attempts to remove default
      privileges on sequences.
    - Fix typo in pg_srand48 seed initialization.
      This led to failure to use all bits of the provided seed. This
      function is not used on most platforms (only those without
      srandom), and the potential security exposure from a
      less-random-than-expected seed seems minimal in any case.
